#ifndef s11n_net_s11n_CLASSLOAD_TPP_INCLUDED
#define s11n_net_s11n_CLASSLOAD_TPP_INCLUDED
// implementations for non-inlined code declared in classload.hpp

template <typename InterfaceBase>
InterfaceBase * ::s11n::cl::classload( const std::string key )
{
	using namespace ::s11n::debug;
	S11N_TRACE(TRACE_FACTORY) << "classload("<<key<<")\n";
	typedef typename ::s11n::type_traits<InterfaceBase>::type IT;
	return object_factory<IT>()( key );
}
template <typename InterfaceBase>
void ::s11n::cl::classloader_register( const std::string & classname, InterfaceBase * (*factory_func)() )
{
	using namespace ::s11n::debug;
	S11N_TRACE(TRACE_FACTORY_REG) << "classloader_register<Base,Sub>("<<classname<<", (FACTORY*))\n";
	::s11n::fac::factory<InterfaceBase>().register_factory( classname, factory_func );
}



#endif // s11n_net_s11n_CLASSLOAD_TPP_INCLUDED
